require 'deploy_dply/helper'
module DeployDply
  class Lib

    def helper
      @helper ||= Helper.new
    end

    def venv
      @venv ||= begin
        require 'deploy_dply/venv'
        venv = Venv.new
        venv.helper = helper
        venv
      end
    end

    def archive(*args, **kwargs)
      require 'deploy_dply/archive'
      Archive.new(*args, **kwargs)
    end

    def newrelic
      @newrelic ||= begin
        require 'deploy_dply/newrelic'
        Newrelic.new
      end
    end

    def require_app_tasks
      return if @app_tasks_loaded
      load 'Rakefile'
      @app_tasks_loaded = true
    end

  end
end
