require 'deploy_dply/lib'

module DeployDply
  module Rake

    def lib
      @lib ||= Lib.new
    end

    def rake(*args, **kwargs)
      lib.helper.rake(*args, **kwargs)
    end

    def sh(*args, **kwargs, &block)
      lib.helper.sh(*args, **kwargs, &block)
    end

    def load_task(task)
      lib.helper.load_task(task)
    end

    def archive(name, **opts, &block)
      archive = lib.archive(name)
      archive.created(**opts, &block)
      return archive
    end

    def set_env(key, value)
      lib.helper.set_env(key, value)
    end

    def role(*roles, &block)
      roles << :all
      if r = roles.find { |r| dply_roles.include? r }
        yield r
      end
    end

    def role?(*roles)
      roles << :all
      roles.find { |r| dply_roles.include? r }
    end

    def require_app_tasks
      lib.require_app_tasks
    end

    def dply_roles
      @dply_roles ||= (ENV["DPLY_ROLES"] || "").strip.split(",").map { |r| r.to_sym }
    end

  end
end
